VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_find_prime_factors"
   ClientHeight    =   1740
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4005
   LinkTopic       =   "Form1"
   ScaleHeight     =   1740
   ScaleWidth      =   4005
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFactors 
      Height          =   735
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   3735
   End
   Begin VB.CommandButton cmdFactor 
      Caption         =   "Factor"
      Default         =   -1  'True
      Height          =   495
      Left            =   2640
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtNumber 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Text            =   "123456"
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Number:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   600
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Factor the number.
Private Sub cmdFactor_Click()
Dim num As Long
Dim factors As New Collection
Dim factor As Variant
Dim result As Long

    ' Get the number's factors.
    num = Val(txtNumber.Text)
    Set factors = FindFactors(num)

    ' Validate the result (for bug-proofing).
    result = 1
    For Each factor In factors
        result = result * factor
    Next factor
    Debug.Assert (result = num)

    ' Display the factors.
    txtFactors.Text = FactorsToString(factors)
End Sub

' Return the number's prime factors.
Private Function FindFactors(ByVal num As Long) As Collection
Dim result As New Collection
Dim factor As Long
    
    ' Take out the 2s.
    Do While (num Mod 2 = 0)
        result.Add 2
        num = num \ 2
    Loop

    ' Take out other primes.
    factor = 3
    Do While (factor * factor <= num)
        If (num Mod factor = 0) Then
            ' This is a factor.
            result.Add factor
            num = num \ factor
        Else
            ' Go to the next odd number.
            factor = factor + 2
        End If
    Loop

    ' If num is not 1, then whatever is left is prime.
    If (num > 1) Then result.Add num

    Set FindFactors = result
End Function

' Return a string like "2 x 3 x 5".
Private Function FactorsToString(ByVal factors As Collection) As String
Dim result As String
Dim factor As Variant

    result = ""
    For Each factor In factors
        result = result & " x " & Format$(factor)
    Next factor

    ' Remove the initial " x ".
    FactorsToString = Mid$(result, 3)
End Function

